import styles from "./styles.module.css";
import Icons from "../icons";
import { useState, useEffect } from "react";

const Search = ({ onSearch, onClose }) => {
  const [text, setText] = useState("");
  useEffect(() => {
    //after 2 second it will execute
    const handler = setTimeout(() => {
      if (text !== "") {
        onSearch(text);
      }
    }, 2000);

    return () => {
      clearTimeout(handler);
    };
  }, [text]);
  const handleSearch = (value) => {
    setText(value);
  };
  const handleCustomClear = (e) => {
    e.preventDefault();
    onClose("");
    setText("");
  };

  return (
    <div className={styles["search-input"]}>
      <span className={`${styles["search-icon"]}`}>
        <Icons name="search" size="small" />
      </span>
      <input
        className={styles.search}
        type="text"
        autoFocus={true}
        value={text}
        onChange={(e) => handleSearch(e.target.value)}
        placeholder="Discover news, articles and more"
      />
      {text && (
        <span className={`${styles["close-icon"]}`} onClick={handleCustomClear}>
          <Icons name="close" />
        </span>
      )}
    </div>
  );
};

export default Search;
